#include "X3D_InterpolationCreator.h"
#include "X3D_ColorInterpolator.h"
#include "X3D_CoordinateInterpolator.h"
#include "X3D_CoordinateInterpolator2D.h"
#include "X3D_NormalInterpolator.h"
#include "X3D_OrientationInterpolator.h"
#include "X3D_PositionInterpolator.h"
#include "X3D_PositionInterpolator2D.h"
#include "X3D_ScalarInterpolator.h"

namespace X3DTK {
namespace X3D {

InterpolationCreator::InterpolationCreator()
{
  defineComponentName("Interpolation", "X3D");

  define(Recorder<ColorInterpolator>::getCreationFunction());
  define(Recorder<CoordinateInterpolator>::getCreationFunction());
  define(Recorder<CoordinateInterpolator2D>::getCreationFunction());
  define(Recorder<NormalInterpolator>::getCreationFunction());
  define(Recorder<OrientationInterpolator>::getCreationFunction());
  define(Recorder<PositionInterpolator>::getCreationFunction());
  define(Recorder<PositionInterpolator2D>::getCreationFunction());
  define(Recorder<ScalarInterpolator>::getCreationFunction());
}

InterpolationCreator::~InterpolationCreator()
{
}

}
}
