#include "X3D_TrimmedSurface.h"
#include "X3D_Contour2D.h"
#include "X3D_NurbsSurface.h"

#include <algorithm>
#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

TrimmedSurface::TrimmedSurface()
: X3DParametricGeometryNode()
{
  define(Recorder<TrimmedSurface>::getTypeName("TrimmedSurface", "NURBS"));
  
  define(Recorder<TrimmedSurface, Contour2D>::getMFNode("trimmingContour", &TrimmedSurface::_trimmingContour));
  
  define(Recorder<TrimmedSurface, NurbsSurface>::getSFNode("surface", &TrimmedSurface::_surface));
}

TrimmedSurface::~TrimmedSurface()
{
  removeChildren();
}

}
}
