#include "MESH_PrimitiveMeshBuilder.h"
#include "X3D_PrimitiveMeshBuilderGeometry3DVisitor.h"
#include "MESH_PrimitiveMeshBuilderStateVariables.h"
#include "DFSGraphTraversal.h"
#include "MESH_Scene.h"

namespace X3DTK {
namespace MESH {

PrimitiveMeshBuilder::PrimitiveMeshBuilder()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  
  setComponentVisitor(new X3D::PrimitiveMeshBuilderGeometry3DVisitor());
}

PrimitiveMeshBuilder::~PrimitiveMeshBuilder()
{
  Singleton<PrimitiveMeshBuilderStateVariables>::removeInstance();
}
  
void PrimitiveMeshBuilder::build(Scene *S, float step, bool boundingBox)
{
  build(static_cast<X3DNode *>(S), step, boundingBox);
}

void PrimitiveMeshBuilder::build(X3DNode *N, float step, bool boundingBox)
{
  Singleton<PrimitiveMeshBuilderStateVariables>::getInstance()->setParameters(step, boundingBox);
  Singleton<PrimitiveMeshBuilderStateVariables>::getInstance()->init();
  traverse(N);
  Singleton<PrimitiveMeshBuilderStateVariables>::getInstance()->finish();
}

}
}
