#include "X3D_WorldCoordTranslatorMulNavigationVisitor.h"
#include "X3D_Inline.h"
#include "X3D_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {


WorldCoordTranslatorMulNavigationVisitor::WorldCoordTranslatorMulNavigationVisitor()
: NavigationVisitor()
{
  define(Recorder<Inline>::getLeaveFunction(&WorldCoordTranslatorMulNavigationVisitor::leaveInline));
}

void WorldCoordTranslatorMulNavigationVisitor::leaveInline(Inline *I) 
{
  WorldCoordTranslatorStateVariables *stateVariables = Singleton<WorldCoordTranslatorStateVariables>::getInstance();
  stateVariables->popNode();
  
  SFNode P = stateVariables->getParent();
  
  P->removeChild(I);
  
  Transform *T = new Transform();
  
  // init T..., en fait si dans la hierarchie de matrices, il n'y a pas de Scale ou 
  // bien une seule, ou encore CNS a voir, on peut remplacer par un seul noeud Transform,
  // autrement il faut laisser la hierarchie et empiler les noeuds Transform.
  
  P->setChild(T);
  T->setChild(I);
}

}
}
