#include "X3D_WorldCoordTranslatorReplaceGroupingVisitor.h"
#include "X3D_Group.h"
#include "X3D_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

WorldCoordTranslatorReplaceGroupingVisitor::WorldCoordTranslatorReplaceGroupingVisitor()
: GroupingVisitor()
{
  // Leave functions.
  define(Recorder<Transform>::getLeaveFunction(&WorldCoordTranslatorReplaceGroupingVisitor::leaveTransform));
}

void WorldCoordTranslatorReplaceGroupingVisitor::leaveTransform(Transform *T) 
{
  WorldCoordTranslatorStateVariables *stateVariables = Singleton<WorldCoordTranslatorStateVariables>::getInstance();

  if (!stateVariables->findProcessedNode(T))
  {
    stateVariables->pushProcessedNode(T);
    
    Group *G = new Group();
    MFNode childList = T->getChildList();
    
    for (MFNode::const_iterator c = childList.begin(); c != childList.end(); ++c)
      G->setChild(*c);
        
    MFNode parentList = T->getParentList();
    
    for (MFNode::const_iterator p = parentList.begin(); p != parentList.end(); ++p)
      (*p)->setChild(G);
    
    delete T;
  }
}

}
}
